package com.gic.spark.tag;

import com.alibaba.fastjson.JSONObject;
import com.gic.spark.datasource.mysql.MysqlDatasource;
import com.gic.spark.datasource.mysql.MysqlRddManager;
import com.gic.spark.datasource.sharding.ShardingRddManager;
import com.gic.spark.entity.SceneCrowdDTO;
import com.gic.spark.entity.TagConditionGroupDTO;
import com.gic.spark.entity.table.TabMemberTagAll;
import com.gic.spark.entity.table.TabSceneCrowd;
import org.apache.spark.sql.Column;
import org.apache.spark.sql.Dataset;

import javax.swing.text.TabSet;
import java.util.ArrayList;
import java.util.List;

import static com.gic.spark.datasource.mysql.MysqlDatasource.JDBC_OPTIONS;

/**
 * @description:
 * @author: wangxk
 * @date: 2020/4/15
 */
public class TagProcess {

    private List<SceneCrowdDTO>sceneCrowdDTOList=new ArrayList();
    private  MysqlRddManager mysqlRddManager;
    private  ShardingRddManager memberShardingRddManager;
    private boolean isProduction;
    private static TagProcess instance;
    public static TagProcess getInstance(){
        if(null==instance){
            instance=new TagProcess();
        }
        return instance;
    }
    private TagProcess(){}

    public boolean isProduction() {
        return isProduction;
    }

    public void init(boolean isProd){
        this.isProduction=isProd;
        MysqlDatasource member4Datasource = new MysqlDatasource();
        if(isProduction){
            member4Datasource.setJdbcUrl("jdbc:mysql://10.0.0.6:3306/gic-member4.0" + JDBC_OPTIONS);
            member4Datasource.setUser("cdb_outerroot");
            member4Datasource.setPassword("@09ui%sbc09");
        }else{
            member4Datasource.setJdbcUrl("jdbc:mysql://10.0.0.6:3306/gic-member4.0" + JDBC_OPTIONS);
            member4Datasource.setUser("cdb_outerroot");
            member4Datasource.setPassword("@09ui%sbc09");
        }
        mysqlRddManager=member4Datasource.buildRddManager();

        Dataset<TabSceneCrowd>sceneCrowdDataset=mysqlRddManager.getPojo("", TabSceneCrowd.class,null)
                                                                .filter(new Column("valid_flag").equalTo(1));
        Dataset<TabMemberTagAll>memberTagAllDataset= mysqlRddManager.getPojo("tab_member_tag_all", TabMemberTagAll.class,null);
        List<TabSceneCrowd> sceneCrowdList=sceneCrowdDataset.collectAsList();
        for(TabSceneCrowd sceneCrowd:sceneCrowdList){
            List<TagConditionGroupDTO>conditionGroupDTOList=JSONObject.parseArray(sceneCrowd.getTag_Condition_Group_Info(),TagConditionGroupDTO.class);
            sceneCrowdDTOList.add(new SceneCrowdDTO(sceneCrowd,conditionGroupDTOList));
        }

    }

    public void process(){

    }
}
